  DEFINT A-Z
  DECLARE SUB Zeller (When$)
  CONST Num$ = "0123456789"
  ON ERROR GOTO Oops
  VIEW PRINT
  CLS
  LOCATE 1, 10, 1
  COLOR 9
  PRINT "Gregorian to Julian & Julian to Gregorian Day/Time Conversion"
Menu:
  VIEW PRINT 3 TO 24
  COLOR 14
  CLS
  PRINT "1. ";
  COLOR 2
  PRINT "Gregorian Date/Time to Julian Day";
  LOCATE 5, 1
  COLOR 14
  PRINT "2. ";
  COLOR 2
  PRINT "Julian Day to Gregorian Date/Time";
  LOCATE 7, 1
  COLOR 14
  PRINT "3. ";
  COLOR 2
  PRINT "Gregorian Date  Days = Gregorian Date";
  LOCATE 9, 1
  COLOR 14
  PRINT "4. ";
  COLOR 2
  PRINT "Gregorian Date  Gregorian Date =  Days";
  LOCATE 11, 4
  PRINT "Choose or ";
  COLOR 14
  PRINT "<Enter>";
  COLOR 2
  PRINT " to Quit: ";
  COLOR 14
  DO
    An$ = INKEY$
    IF LEN(An$) THEN
      IF An$ = CHR$(13) THEN
        VIEW PRINT
        COLOR 7
        CLS
        SYSTEM
      ELSEIF INSTR("1234", An$) THEN
        EXIT DO
      END IF
    END IF
  LOOP
  PRINT "<"; An$; ">";
  LOCATE 13, 1
  COLOR 2
  PRINT STRING$(80, "_");
Backwards:
  VIEW PRINT 15 TO 24
  COLOR 14
  CLS
  IF An$ = "1" THEN
    GOSUB Gregorian2JulianDate
    IF WhatDate$ = "" THEN
      RUN
    END IF
    GOSUB Gregorian2JulianTime
    Zeller WhatDate$
    GOTO Escape
  ELSEIF An$ = "2" THEN
    COLOR 2
    PRINT "Julian Day ( 1721425.5): ";
    COLOR 14
    LINE INPUT ; Julian$
    Julian$ = LTRIM$(RTRIM$(Julian$))
    IF Julian$ = "" THEN
      RUN
    ELSEIF LEFT$(Julian$, 1) = "." THEN
      GOTO Backwards
    END IF
    Decimal = INSTR(Julian$, ".")
    IF Decimal THEN
      FOR X = 1 TO Decimal - 1
        IF INSTR(Num$, MID$(Julian$, X, 1)) = 0 THEN
          GOTO Backwards
        END IF
      NEXT X
      FOR X = Decimal + 1 TO LEN(Julian$)
        IF INSTR(Num$, MID$(Julian$, X, 1)) = 0 THEN
          GOTO Backwards
        END IF
      NEXT X
    ELSE
      FOR X = 1 TO LEN(Julian$)
        IF INSTR(Num$, MID$(Julian$, X, 1)) = 0 THEN
          GOTO Backwards
        END IF
      NEXT X
    END IF
    Julian# = VAL(Julian$)
    IF Julian# < 1721425.5# THEN
      GOTO Backwards
    END IF
    GOSUB Julian2GregorianDate
    GOSUB Julian2GregorianTime
    LOCATE 17, 1
    COLOR 2
    PRINT "Gregorian Date (MM/DD/YYYY): ";
    COLOR 14
    PRINT WhatDate$;
    LOCATE 19, 1
    COLOR 2
    PRINT "Gregorian Time (HH:MM:SS): ";
    COLOR 14
    PRINT WhatTime$;
    WhatDate$ = LEFT$(WhatDate$, 2) + MID$(WhatDate$, 4, 2) + RIGHT$(WhatDate$, 4)
    Zeller WhatDate$
    GOTO Escape
  ELSEIF An$ = "3" THEN
    GOSUB Gregorian2JulianDate
    IF WhatDate$ = "" THEN
      RUN
    END IF
    GOSUB AddDays
    IF Day$ = "" THEN
      GOTO Backwards
    END IF
    Julian# = Julian# + Days#
    GOSUB Julian2GregorianDate
    LOCATE 21, 1
    COLOR 2
    PRINT "New Gregorian Date (MM/DD/YYYY): ";
    COLOR 14
    PRINT WhatDate$;
    GOTO Escape
  ELSEIF An$ = "4" THEN
    GOSUB Gregorian2JulianDate
    IF WhatDate$ = "" THEN
      RUN
    END IF
    Julian1# = Julian#
    VIEW PRINT 18 TO 24
    GOSUB Gregorian2JulianDate
    IF WhatDate$ = "" THEN
      GOTO Backwards
    END IF
    Julian2# = Julian#
    Julian# = ABS(Julian1# - Julian2#)
    IF Julian1# <= Julian2# THEN
      Days# = Julian#
    ELSE
      Days# = -Julian#
    END IF
    LOCATE 21, 1
    COLOR 2
    PRINT "Number of Days:";
    IF Days# < 0 THEN
      PRINT " ";
    END IF
    COLOR 14
    PRINT Days#;
    GOTO Escape
  END IF
Gregorian2JulianDate:
  COLOR 14
  CLS
  COLOR 2
  PRINT "Gregorian Date (MMDDYYYY): ";
  COLOR 14
  LINE INPUT ; WhatDate$
  WhatDate$ = LTRIM$(RTRIM$(WhatDate$))
  IF WhatDate$ = "" THEN
    RETURN
  ELSEIF LEN(WhatDate$) <> 8 THEN
    GOTO Gregorian2JulianDate
  END IF
  WhatMonth& = VAL(LEFT$(WhatDate$, 2))
  WhatDay& = VAL(MID$(WhatDate$, 3, 2))
  WhatYear& = VAL(RIGHT$(WhatDate$, 4))
  IF WhatYear& <= 0 THEN
    GOTO Gregorian2JulianDate
  ELSEIF WhatMonth& < 1 OR WhatMonth& > 12 THEN
    GOTO Gregorian2JulianDate
  ELSEIF WhatDay& < 1 THEN
    GOTO Gregorian2JulianDate
  ELSEIF WhatMonth& = 2 THEN
    IF WhatDay& > 28 THEN
      IF WhatYear& / 4 <> WhatYear& \ 4 THEN
        GOTO Gregorian2JulianDate
      ELSEIF WhatYear& / 100 = WhatYear& \ 100 THEN
        IF WhatYear& / 400 <> WhatYear& \ 400 THEN
          GOTO Gregorian2JulianDate
        END IF
      END IF
    END IF
  ELSEIF WhatMonth& = 4 OR WhatMonth& = 6 OR WhatMonth& = 9 OR WhatMonth& = 11 THEN
    IF WhatDay& > 30 THEN
      GOTO Gregorian2JulianDate
    END IF
  ELSEIF WhatDay& > 31 THEN
    GOTO Gregorian2JulianDate
  END IF
  A& = (14 - WhatMonth&) \ 12
  Y& = WhatYear& + 4800 - A&
  M& = WhatMonth& + 12 * A& - 3
  Julian# = WhatDay& + (153 * M& + 2) \ 5 + 365 * Y& + Y& \ 4 - Y& \ 100 + Y& \ 400 - 32045
  RETURN
Gregorian2JulianTime:
  VIEW PRINT 17 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT "24-Hour Time ";
  COLOR 14
  PRINT "<Enter>";
  COLOR 2
  PRINT " or (HHMMSS): ";
  COLOR 14
  LINE INPUT ; WhatTime$
  WhatTime$ = LTRIM$(RTRIM$(WhatTime$))
  IF WhatTime$ = "" THEN
    PRINT "000000"
    GOTO Skip
  ELSEIF LEN(WhatTime$) <> 6 THEN
    GOTO Gregorian2JulianTime
  END IF
  WhatHour# = VAL(LEFT$(WhatTime$, 2))
  WhatMinute# = VAL(MID$(WhatTime$, 3, 2))
  WhatSecond# = VAL(RIGHT$(WhatTime$, 2))
  IF WhatHour# < 0 OR WhatHour# > 23 THEN
    GOTO Gregorian2JulianTime
  ELSEIF WhatMinute# < 0 OR WhatMinute# > 59 THEN
    GOTO Gregorian2JulianTime
  ELSEIF WhatSecond# < 0 OR WhatSecond# > 59 THEN
    GOTO Gregorian2JulianTime
  END IF
Skip:
  WhatTime# = WhatHour# / 24 + WhatMinute# / 1440 + WhatSecond# / 86400 - .5
  Julian# = Julian# + WhatTime#
  LOCATE 19, 1
  COLOR 2
  PRINT "The Julian Day: ";
  COLOR 14
  PRINT USING "########,.########"; Julian#;
  RETURN
Julian2GregorianDate:
  A# = Julian# + 32044
  B# = (4 * A# + 3) \ 146097
  C# = A# - (146097 * B#) \ 4
  D# = (4 * C# + 3) \ 1461
  E# = C# - (1461 * D#) \ 4
  M# = (5 * E# + 2) \ 153
  Day# = E# - (153 * M# + 2) \ 5 + 1
  Day# = FIX(Day# + .5)
  Month# = M# + 3 - 12 * (M# \ 10)
  Month# = FIX(Month# + .5)
  Year# = 100 * B# + D# - 4800 + M# \ 10
  Year# = FIX(Year# + .5)
  Month$ = MID$(STR$(Month#), 2)
  IF LEN(Month$) = 1 THEN
    Month$ = "0" + Month$
  END IF
  Day$ = MID$(STR$(Day#), 2)
  IF LEN(Day$) = 1 THEN
    Day$ = "0" + Day$
  END IF
  IF Year# > 0 THEN
    Year$ = MID$(STR$(Year#), 2)
  ELSEIF Year# = 0 THEN
    Year$ = "0000"
  END IF
  IF Year# > 0 THEN
    IF LEN(Year$) <> 4 THEN
      Year$ = STRING$(4 - LEN(Year$), "0") + Year$
    END IF
  END IF
  WhatDate$ = Month$ + "/" + Day$ + "/" + Year$
  RETURN
Julian2GregorianTime:
  IF FIX(Julian#) = Julian# THEN
    WhatTime$ = "12:00:00"
    RETURN
  END IF
  WhatHour# = 24 * (Julian# - FIX(Julian#)) + 12
  WhatMinute# = 60 * (WhatHour# - FIX(WhatHour#))
  WhatSecond# = 60 * (WhatMinute# - FIX(WhatMinute#))
  WhatSecond# = FIX(WhatSecond# + .5)
  IF WhatSecond# = 60 THEN
    WhatSecond# = 0
    WhatMinute# = WhatMinute# + 1
  END IF
  IF WhatMinute# = 60 THEN
    WhatMinute# = 0
    WhatHour# = WhatHour# + 1
  END IF
  IF WhatHour# >= 24 THEN
    WhatHour# = WhatHour# - 24
  END IF
  WhatHour$ = MID$(STR$(FIX(WhatHour#)), 2)
  IF LEN(WhatHour$) = 1 THEN
    WhatHour$ = "0" + WhatHour$
  END IF
  WhatMinute$ = MID$(STR$(FIX(WhatMinute#)), 2)
  IF LEN(WhatMinute$) = 1 THEN
    WhatMinute$ = "0" + WhatMinute$
  END IF
  WhatSecond$ = MID$(STR$(FIX(WhatSecond#)), 2)
  IF LEN(WhatSecond$) = 1 THEN
    WhatSecond$ = "0" + MID$(STR$(WhatSecond#), 2)
  ELSE
    WhatSecond$ = MID$(STR$(WhatSecond#), 2)
  END IF
  WhatTime$ = WhatHour$ + ":" + WhatMinute$ + ":" + WhatSecond$
  RETURN
AddDays:
  VIEW PRINT 18 TO 24
  COLOR 14
  CLS
  COLOR 2
  PRINT " Days: ";
  COLOR 14
  LINE INPUT ; Day$
  Day$ = LTRIM$(RTRIM$(Day$))
  IF Day$ = "" THEN
    RETURN
  END IF
  IF LEFT$(Day$, 1) = "-" THEN
    Start = 2
  ELSE
    Start = 1
  END IF
  FOR X = Start TO LEN(Day$)
    IF INSTR(Num$, MID$(Day$, X, 1)) = 0 THEN
      GOTO AddDays
    END IF
  NEXT X
  Days# = VAL(Day$)
  RETURN
Oops:
  LOCATE 24, 35
  PRINT "(Overflow)";
Escape:
  LOCATE 25, 31, 0
  COLOR 2
  PRINT "(Hit ";
  COLOR 14
  PRINT "<Esc>";
  COLOR 2
  PRINT " to Run)";
  DO
    An$ = INKEY$
    IF LEN(An$) THEN
      IF An$ = CHR$(27) THEN
        RUN
      END IF
    END IF
  LOOP

SUB Zeller (WhatDate$)
  Allday$ = " 1 2 3 4 5 6 7 8 910111213141516171819202122232425262728293031"
  Week$ = "SUN MON TUE WED THU FRI SAT"
  D = VAL(MID$(WhatDate$, 3, 2))
  M = VAL(LEFT$(WhatDate$, 2))
  Cen = VAL(MID$(WhatDate$, 5, 2))
  Y = VAL(RIGHT$(WhatDate$, 2))
  IF M = 4 OR M = 6 OR M = 9 OR M = 11 THEN
    MAX = 30
    GOTO Bypass1
  END IF
  IF M <> 2 THEN
    MAX = 31
    GOTO Bypass1
  END IF
  M1 = 12
  D1 = 29
  Y1 = Y - 1
  Cen1 = Cen
  IF Y1 = -1 THEN
    Y1 = 99
    Cen1 = Cen1 - 1
  END IF
  GOSUB LocalSub
  F1 = F
  M1 = 1
  D1 = 1
  Y1 = Y
  Cen1 = Cen
  GOSUB LocalSub
  IF F1 = F THEN
    MAX = 28
  ELSE
    MAX = 29
  END IF
Bypass1:
  IF M > 2 THEN
    M = M - 2
  ELSE
    M = M + 10
    Y = Y - 1
    IF Y = -1 THEN
      Y = 99
      Cen = Cen - 1
    END IF
  END IF
  F = (((26 * M - 2) \ 10) + D + Y + (Y \ 4) + (Cen \ 4) - 2 * Cen) MOD 7
  IF F < 0 THEN
    F = F + 7
  END IF
  VIEW PRINT 15 TO 24
  LOCATE 15, 58
  COLOR 14
  PRINT LEFT$(WhatDate$, 2); "/"; MID$(WhatDate$, 3, 2); "/"; RIGHT$(WhatDate$, 4)
  LOCATE 17, 50
  COLOR 15
  PRINT Week$
  LOCATE 18, 50
  M1 = M
  D1 = 1
  Y1 = Y
  Cen1 = Cen
  GOSUB LocalSub
  Y = 1
  FOR X = 1 TO MAX
    LOCATE CSRLIN, F * 4 + 50
    IF VAL(MID$(Allday$, Y, 2)) = D THEN
      COLOR 14
      PRINT MID$(Allday$, Y, 2);
      COLOR 15
      GOTO Bypass2
    END IF
    PRINT MID$(Allday$, Y, 2);
Bypass2:
    Y = Y + 2
    F = F + 1
    IF F > 6 THEN
      F = 0
      PRINT
    END IF
  NEXT X
  IF VAL(RIGHT$(WhatDate$, 4)) < 1583 THEN
    LOCATE CSRLIN + 1, 50
    COLOR 14
    PRINT "(Gregorian Calendar  1583)";
  END IF
  EXIT SUB
LocalSub:
  F = (((26 * M1 - 2) \ 10) + D1 + Y1 + (Y1 \ 4) + (Cen1 \ 4) - 2 * Cen1) MOD 7
  IF F < 0 THEN
    F = F + 7
  END IF
  RETURN
END SUB

